/*
 * JVConfig.java
 *
 * Created on 19. Oktober 2003, 21:17
 */

package org.jvisu.applets;

import java.awt.*;
import java.net.*;
import org.jvisu.base.*;
import org.jvisu.util.*;
import javax.swing.*;
import cz.dhl.ftp.*;
import java.net.*;
import java.io.*;
import java.nio.*;
import java.nio.channels.*;
import java.util.*;
import java.util.zip.*;

/** Configuration editor applet
 *
 *  <p>package:  org.jvisu.applets</p>
 *  <p>file:    JVConfig.java</p>
 *  <p>$Id: JVConfig.java 288 2004-09-21 08:22:22Z tgl $ </p>
 *  <p>Copyright 2003 Thomas Gleixner <tglx@linutronix.de></p>
 *
 *  <p>This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License version 2 as
 *  published by the Free Software Foundation. See file LICENCE in this
 *  directory</p>
 *  
 *  <p>Change Log:</p>
 *  <ul>
 *  <li> 1.0 Initial inmplimentation </li>
 *  </ul>
 *  <p>
 *  Configuration editor applet
 *  </p>
 *
 * @author Thomas Gleixner <tglx@linutronix.de>
 * @version 1.0 
*/
public class JVConfig extends javax.swing.JApplet {
    
    private int userlevel;
    /* Password strings for userlevel access*/
    private String[] passwords = {"","passwordlevel1","passwordlevel2","service"};
    /* Update online connection */
    private JVBool update = null;	
    /* Configuration file name */
    private String configfile;
    /* Passwordfile  */
    private String passwdfile;
    /* Button to load defaults */
    private JButton butLoadDefaults;
    /* Button to change passwords */
    private JButton butChangePass;
    /* FTP username */
    private String ftpusername = "silocontrol";
    /* FTP password */
    private String ftppassword = "silo1234";
    /* The configuration tree */
    private org.jvisu.base.JVConfig ConfTree;
    
    /** Initializes the applet JVConfig */
    public void init() {
        initComponents();
        URL base = this.getDocumentBase();
        String conf = getParameter("configfile");
        ConfTree.setUsername(ftpusername);
        ConfTree.setPassword(ftppassword);
        String serv = getParameter("server");
        if (serv == null)
            serv = base.getHost();
        if (conf != null) {
            String proto = getParameter("protocol");
            if (proto == null)
                proto = "http://";
            if (!base.getProtocol().startsWith("file")) {
                configfile = proto + serv + conf;
            } else {
                try {
                    URL cnf = new URL(base, conf);
                    configfile = cnf.toString();
                } catch (Exception e) { }
            }
            ConfTree.setConfigFile(configfile);
        }
	ConfTree.setEditEnabled(true);
	String updvar = getParameter("update");
	if (updvar != null) {
		update = new JVBool();
                getContentPane().add(update, java.awt.BorderLayout.SOUTH);
		update.setCommtype("org.jvisu.comm.JVSockComm");
		update.setServer (serv);
                int port = org.jvisu.util.param.JVParams.StringToInt(getParameter("port"), 2200);
		update.setPort (port);
		update.setCommVar(updvar);
	}
        try {
            passwdfile = configfile.substring(0,configfile.lastIndexOf('.'));
            passwdfile += ".pwd.gz";
            ReadPasswordFile(new URL(passwdfile));
        } catch (Exception e) { }
    }
    
    public void destroy() {
        
    }
    
    /** This method is called from within the init() method to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {
        ConfTree = new org.jvisu.base.JVConfig();
        JPanel pan = new JPanel();
        
        JButton butsave = new JButton("Speichern");
        butsave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MenuSaveActionPerformed(evt);
            }
        });
        pan.add(butsave);

        butLoadDefaults = new JButton("Werkseinstellung");
        butLoadDefaults.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MenuLoadBackupActionPerformed(evt);
            }
        });
        butLoadDefaults.setEnabled(false);
        pan.add(butLoadDefaults);

        butChangePass = new JButton("Passwort");
        butChangePass.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MenuChangePassActionPerformed(evt);
            }
        });
        butChangePass.setEnabled(false);
        pan.add(butChangePass);
        
        String[] sel = { "Benutzerebene 0", "Benutzerebene 1", "Benutzerebene 2", "Serviceebene" };
        JComboBox usrCombo = new JComboBox(sel);
        usrCombo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MenuUserLevelActionPerformed(evt);
            }
        });
        pan.add(usrCombo);
        
        getContentPane().add(pan, java.awt.BorderLayout.NORTH);
        getContentPane().add(ConfTree, java.awt.BorderLayout.CENTER);
    }

    private void MenuChangePassActionPerformed(java.awt.event.ActionEvent evt) {
        JVPasswordDlg pwddlg = new JVPasswordDlg(null);
        pwddlg.setLocationRelativeTo(this.getContentPane());
        pwddlg.setTitle("Passwort aendern");
        String[] newpass = new String[3];
        for (int i = 1; i < 3;) {
            pwddlg.setMessage("Passwort Benutzerebene " + i + " eingeben");
            pwddlg.setPass("");
            if (pwddlg.showDialog() != true)
                return;
            newpass[i] = pwddlg.getPass();
            pwddlg.setPass("");
            pwddlg.setMessage("Passwort Benutzerebene " + i + " bestaetigen");
            if (pwddlg.showDialog() != true)
                return;
            if (pwddlg.getPass().compareTo(newpass[i]) != 0) {
                JOptionPane.showMessageDialog(this.getContentPane(),
                    "Passwoerter stimmen nicht ueberein !");
                continue;
            }
            i++;
        }
        if (JOptionPane.showConfirmDialog(this.getContentPane(),
                "Passwoerter speichern ?", 
                "Wollen Sie die Passwoerter speichern ?", 
                JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
                String fstream;
                fstream = "P1:" + newpass[1] + "\n";
                fstream += "P2:" + newpass[2] + "\n";
                ConfTree.WriteFile(passwdfile, fstream);
                passwords[1] = newpass[1];
                passwords[2] = newpass[2];
        }
    }

    private void MenuLoadBackupActionPerformed(java.awt.event.ActionEvent evt) {
        if (JOptionPane.showConfirmDialog(this.getContentPane(),
                "Werkseinstellung laden", 
                "Wollen Sie wirklich die Werkseinstellung laden ?", 
                JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
         
                    ConfTree.LoadBackupFile();
        }
    }

    private void MenuUserLevelActionPerformed(java.awt.event.ActionEvent evt) {
        JComboBox sel = (JComboBox) evt.getSource();
        int newlevel = sel.getSelectedIndex();
        int valid = 0;
        if (newlevel == ConfTree.getUserlevel())
            return;
        if (newlevel > userlevel) {
            JVPasswordDlg pwddlg = new JVPasswordDlg(null);
            pwddlg.setLocationRelativeTo(this.getContentPane());
            if (pwddlg.showDialog() == true) {
                for (int i = newlevel; i < passwords.length; i++) {
                    if (pwddlg.getPass().compareTo(passwords[i]) == 0)
                        valid = 1;
                }
            }
        } else
            valid = 1;
        if (valid > 0) {
            userlevel = newlevel;
            ConfTree.setUserlevel(userlevel);
        } else {
            sel.setSelectedIndex(ConfTree.getUserlevel());
        }
        butLoadDefaults.setEnabled(userlevel >= 2);
        butChangePass.setEnabled(userlevel >= 2);
    }

    private void MenuSaveActionPerformed(java.awt.event.ActionEvent evt) {
        // Add your handling code here:
        setCursor(Cursor.getPredefinedCursor(java.awt.Cursor.WAIT_CURSOR));
        ConfTree.SaveTree();
	if (update != null) {
		update.setValue(true);
	}	
        setCursor(Cursor.getPredefinedCursor(java.awt.Cursor.DEFAULT_CURSOR));
    }
  
    /** Read a password file
     *  @param file File to read passwords
     *  @return 0 on success
     **/
    private int ReadPasswordFile (URL ctrl) {
        Ftp ftp = null;
        try {
            InputStream in;
            if (ctrl.getProtocol().compareTo("ftp") == 0) {
                ftp = new Ftp();
		if (!ftp.connect (ctrl.getHost(), 21)) {
			ftp.abort();
			return -1;
		}
		if (!ftp.login (ftpusername, ftppassword)) {
			ftp.abort();
			return -1;
		}
		String txt = ctrl.getPath();
		if (txt.charAt(0) == '/')
			txt = txt.substring(1);
		FtpFile ffile = new FtpFile (txt, ftp);
		if (ffile == null) {
			ftp.abort();
			return -1;
		}
		in = ffile.getInputStream();	
            } else {
                URLConnection ctrlConnection = ctrl.openConnection ();                               
                in = ctrlConnection.getInputStream (); 
            }
            System.out.println(in);
            if (ctrl.getFile().endsWith(".gz"))
                in = new GZIPInputStream(in);
            BufferedReader br = new BufferedReader (new InputStreamReader (in));
            String line;
            while ((line = br.readLine()) != null) {
                if (line.startsWith("P1:"))
                    passwords[1] = line.substring(3);
                if (line.startsWith("P2:"))
                    passwords[2] = line.substring(3);
            }
        } catch (Exception e2) { System.out.println (e2);}
        if (ftp != null) {
		if (ftp.isConnected())
			ftp.abort();
	}
	return 0;
    }
   
}
