/*
 * JVConfig.java
 *
 * Created on 19. Oktober 2003, 21:17
 */

package org.jvisu.applets;

import java.net.*;
import org.jvisu.base.*;
import org.jvisu.panel.*;
import javax.swing.*;
import org.jvisu.util.param.JVParams;

/** Panel applet
 *
 *  <p>package:  org.jvisu.applets</p>
 *  <p>file:    JVPanel.java</p>
 *  <p>$Id: JVPanel.java 288 2004-09-21 08:22:22Z tgl $ </p>
 *  <p>Copyright 2003 Thomas Gleixner <tglx@linutronix.de></p>
 *
 *  <p>This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License version 2 as
 *  published by the Free Software Foundation. See file LICENCE in this
 *  directory</p>
 *  
 *  <p>Change Log:</p>
 *  <ul>
 *  <li> 1.0 Initial inmplimentation </li>
 *  </ul>
 *  <p>
 *  Panel applet to display a JVisu xml
 *  </p>
 *
 * @author Thomas Gleixner <tglx@linutronix.de>
 * @version 1.0 
*/
public class JVPanel extends javax.swing.JApplet {
    
    private JVBasePanel jVPanel1;
    
    /** Initializes the applet JVConfig */
    public void init() {
        jVPanel1 = new JVBasePanel();
        getContentPane().add(jVPanel1, java.awt.BorderLayout.CENTER);

        /* Get the document base */
        URL url = this.getDocumentBase();
        
        String base = url.toString();

        /** Get the configuration file */
        String conf = getParameter("configfile");

        /* Check, if the configfile is absolute to server root */
        String isabs = getParameter("isabsolutepath");
        if (isabs != null && isabs.equalsIgnoreCase("true")) {
            if (!url.getProtocol().startsWith("file"))
                base = url.getProtocol() + "://" + url.getHost()+ ":" + url.getPort();
            else
                base = url.getProtocol() + "://" + url.getHost();
            base = base + "/" + conf;
        }
        
        jVPanel1.setBase(base);
        jVPanel1.setConfigFile(conf);

        String serv = getParameter("server");
        if (serv == null)
            serv = this.getDocumentBase().getHost();
        jVPanel1.setServer(serv);
        String editenable = getParameter("editenable");
        if (editenable != null && editenable.equalsIgnoreCase("true"))
            jVPanel1.setEditEnabled(true);
        
        double zoom = JVParams.StringToDouble(getParameter("zoomfactor"), 1.0);
        jVPanel1.setZoomfactor(zoom);
    }
    
    /** Called, when the applet is going to be disposed 
     *  Remove all components to free the JVBeans resources
     */
    public void destroy () {
        getContentPane().removeAll();
    }
}
