package org.jvisu.panel.configurator;

import java.awt.*;
import javax.swing.*;

/** Description Cell panel
 *  <p>package:    org.jvisu.panel.configurator</p>
 *  <p>file:       JVDescrCellPanel.java</p>
 * $Id: JVDescrCellPanel.java 275 2004-04-19 08:20:55Z tgl $
 *
 *  <p>Copyright 2003 Thomas Gleixner <tglx@linutronix.de></p>
 *
 * <p>This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License version 2 as
 *  published by the Free Software Foundation.</p>
 * </p>
 *
 * Change Log:
 * </p>
 * <ul>
 * <li> 1.0 First implementation
 * </ul>
 * <p>
 * Convenience class to hold descirptions for property cells
 * </p>
 *
 * @author Thomas Gleixner <tglx@linutronix.de>
 * @version 1.3
 */
public class JVDescrCellPanel extends JVCellPanel {
    
    /** Creates a new instance of JVPanelPropertyEditor 
     *  @param descr text to display
     *  @param size size of this component
     *  @param font font descriptor
     */
    public JVDescrCellPanel(String descr, Dimension size, Font font) {
        super(size, font);
        JLabel lbl = new JLabel("  " + descr);
        lbl.setFont(font);
        add(lbl, BorderLayout.WEST);
    }
}