package org.jvisu.panel.configurator;

import java.awt.*;
import javax.swing.*;
import javax.swing.tree.*;
/**
 *  <p>package:    org.jvisu.panel</p>
 *  <p>file:       JVPanelTreeRenderer.java</p>
 * $Id: JVPanelTreeRenderer.java 275 2004-04-19 08:20:55Z tgl $
 *
 *  <p>Copyright 2003 Thomas Gleixner <tglx@linutronix.de></p>
 *
 * <p>This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License version 2 as
 *  published by the Free Software Foundation.</p>
 * </p>
 *
 * Change Log:
 * </p>
 * <ul>
 * <li> 1.0 First implementation
 * </ul>
 * <p>
 *	rendering helper for JVPanelTree
 * </p>
 *
 * @author Thomas Gleixner <tglx@linutronix.de>
 * @version 1.3
 */
public class JVPanelTreeRenderer extends DefaultTreeCellRenderer {
    
    /** Creates a new instance of JVSubPanel */
    public JVPanelTreeRenderer() {
    }
    
    public Component getTreeCellRendererComponent(
                        JTree tree,
                        Object value,
                        boolean sel,
                        boolean expanded,
                        boolean leaf,
                        int row,
                        boolean hasFocus) {

        super.getTreeCellRendererComponent(
                        tree, value, sel,
                        expanded, leaf, row,
                        hasFocus);
        
        if (!expanded && !leaf)
            return this;
        
        try {
            setIcon( ((JVPanelTreeComponent) ((DefaultMutableTreeNode) value).getUserObject()).getIcon());
        } catch (Exception e) { }

        return this;
    }

    
}
