package org.jvisu.panel.configurator;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 *  <p>package:    org.jvisu.panel</p>
 *  <p>file:       JVTopPanel.java</p>
 * $Id: JVTopPanel.java 275 2004-04-19 08:20:55Z tgl $
 *
 *  <p>Copyright 2003 Thomas Gleixner <tglx@linutronix.de></p>
 *
 * <p>This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License version 2 as
 *  published by the Free Software Foundation.</p>
 * </p>
 *
 * Change Log:
 * </p>
 * <ul>
 * <li> 1.0 First implementation
 * </ul>
 * <p>
 * </p>
 * JVTopPanel is the top cover of JVPanelEdit in the JVPanelEditor. 
 * It is transparent and receives the mouse events as it is the top 
 * layer in the design
 *
 * @author Thomas Gleixner <tglx@linutronix.de>
 * @version 1.3
 */
public class JVTopPanel extends javax.swing.JPanel {
    
    /** The selected component */
    private Rectangle selection;
    
    /** Creates a new instance of JVSubPanel */
    public JVTopPanel() {
        selection = new Rectangle();
        setOpaque(false);
    }

    /** Set the selection rectangle
     *  @param sel the selected rectangle
     */
    public void setSelection(Rectangle sel) {
        if (sel.equals(selection))
                return;
        selection.setBounds(sel);
        repaint();
    }

    /** Get the selection rectangle
     *  @return the selected rectangle
     */
    public Rectangle getSelection() {
        return selection;
    }

    /** Paint component is used to draw selection rectangles
     *  for the currently selected component
     */
    public void paintComponent(Graphics g) {
        if (!selection.isEmpty()) {
            g.setColor(Color.BLUE);
            g.drawRect(selection.x, selection.y, selection.width, selection.height);
            g.drawRect(selection.x+1, selection.y+1, selection.width-2, selection.height-2);
        }
    }
}
