package org.jvisu.panel.configurator.editors;

import java.beans.*;

/** Interface for JVisu alignment constants.
 *
 *  <p>$Id: JVOrientation.java 189 2003-11-20 11:51:28Z tgl $
 *  </p>
 *  <p>Copyright 2003 Thomas Gleixner <tglx@linutronix.de></p>
 *
 *  <p>This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License version 2 as
 *  published by the Free Software Foundation. See file LICENCE in this
 *  directory</p>
 *  
 *  <p>Change Log:</p>
 *  <ul>
 *  <li> 1.0 Initial inmplimentation </li>
 *  </ul>
 *  <p>
 *  <p>Declaration of the alignment constants for JVisu
 *  </p>
 *
 * @author Thomas Gleixner <tglx@linutronix.de>
 * @version 1.0 
*/
public final class JVOrientation extends PropertyEditorSupport {
    
    /** constants for a property editor */
    public final static String[] orientinfo = {
        "Horizontal",
        "Vertical",
    };
    
    /** Create a new instance */
    public JVOrientation(Object source) {
        super(source);
    }
        
    /** provide the tags for this property
    */
    public final String[] getTags() {
        return orientinfo;
    }

    /** Getter for property aligncontent.
     * @return Value of property aligncontent.
     */
    public String getAsText() {
        int i = ((Integer) super.getValue()).intValue();
        return orientinfo[i];
    }
    
    /** Setter for property aligncontent.
     * @param val Value of property aligncontent.
     */
    public void setAsText(String val) {
        if (val == null)
            return;
        for (int i = 0; i < orientinfo.length; i++) {
            if (val.compareTo((orientinfo[i])) == 0) {
                super.setValue(new Integer(i));
                break;
            }
        }
    }
}
